Attribute VB_Name = "Module1"
Sub Main()
'Declare variables
Static objApp As SolidEdgeFramework.Application
Static objDoc As Object
Static strSaveName As String
Static strFileName As String
'
    On Error Resume Next
    Do
        'Connect to a running instance of Solid Edge
        Set objApp = GetObject(, "SolidEdge.Application")
        If Err Then
            Err.Clear
            If MsgBox("Bitte zuerst gewnschte Datei ffnen," & vbNewLine _
                    & "SolidEdge ist nicht aktiv!", vbExclamation + vbRetryCancel, "UnLock - Fehler") = vbCancel Then
                GoTo Unlock_Exit:
            End If
        Else
            '
            'Access the active document.
            If objApp.Documents.Count < 1 Then
                 If MsgBox("Es ist kein Dokument geffnet!", _
                        vbExclamation + vbRetryCancel, "UnLock - Fehler") = vbCancel Then
                    GoTo Unlock_Exit:
                 End If
            Else
                 Set objDoc = objApp.ActiveDocument
                 Exit Do
            End If
        End If
    Loop
           
    On Error GoTo Unlock_Exit
    '
    ' Dateinamen sichern
    strFileName = objDoc.FullName
    '
    ' neuen Namen erstellen
    ' let's do it simple to be able to handle files without extension too
    strSaveName = strFileName & ".sav"
    '
    'Datei mit Endung .sav speichern und als aktuell ffnen, Status zurcksetzen
    objDoc.SaveAs newname:=strSaveName, NewStatus:=igStatusAvailable
    
    'aktuelle Datei (*.sav) schlieen
    objDoc.Close savechanges = False
    
    If MsgBox("Soll der Status folgender Datei wirklich zurckgesetzt werden?" & vbNewLine & _
            strFileName, vbOKCancel, "UnLock - Letzte Warnung") = vbOK Then
            'kopiere die verfgbare *.sav Datei ber die rsprngliche Datei
            FileCopy strSaveName, strFileName
    End If
    '
    ' loeschen Sicherungskopie
    Kill strSaveName
    '
    ' we do not need the return value so a call would be sufficient
    Set objDoc = objApp.Documents.Open(FileName:=strFileName)
    '
Unlock_Exit:
    If Err.Number <> 0 Then
        MsgBox "Der Kopiervorgang ist fehlgeschlagen: " & Err.Description
        Kill strSaveName
    End If
    '
    ' clean up
    Set objApp = Nothing
    Set objDoc = Nothing
    '
End Sub
